package descartes.kieker4dql.dqlconnector.structures.records;

import descartes.kieker4dql.dqlconnector.structures.identifier.ComponentIdentifier;

public class EventRecord extends AbstractRecord<ComponentIdentifier>{
	
	private String requestIdentifier;
	private long exTime;
	
	public String getRequestIdentifier() {
		return requestIdentifier;
	}

	public long getRuntime() {
		return exTime;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + (int) (exTime ^ (exTime >>> 32));
		result = prime
				* result
				+ ((requestIdentifier == null) ? 0 : requestIdentifier
						.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		EventRecord other = (EventRecord) obj;
		if (exTime != other.exTime)
			return false;
		if (requestIdentifier == null) {
			if (other.requestIdentifier != null)
				return false;
		} else if (!requestIdentifier.equals(other.requestIdentifier))
			return false;
		return true;
	}

	public void setRequestIdentifier(String requestIdentifier) {
		this.requestIdentifier = requestIdentifier;
	}
	
	public EventRecord(ComponentIdentifier componentIdentifier,long timestamp, long exTime, String requestID) {
		super.setIdentifier(componentIdentifier);
		super.setTimestamp(timestamp);
		this.exTime = exTime;
		this.requestIdentifier=requestID; 
	}

	
	@Override
	public String toString() {
		return super.toString()  + "\t| runtime: "+ exTime + "\t| request: "+ requestIdentifier;
	}


	

}
